<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="api_faq_add_form_control_from_filter">
  <title>Dynamically Add Form Controls Using a Styles Filter</title>
  <body>
    <section id="question">
      <title>Use Case</title>
      <p id="p_mjg_dgk_54b">You want to add form controls using an API.</p>
    </section>
    <section id="answer">
      <title>Solution</title>
      <p id="p_njg_dgk_54b">Usually, a form control is added from the CSS using one of the <xref
          href="form-controls.dita#form-controls">built-in form controls</xref>. However, in some
        cases you do not have all the information you need to properly initialize the form control
        at CSS level. In these cases you can add the form controls by using the API, more
        specifically <xref
          href="https://www.oxygenxml.com/InstData/Editor/SDK/javadoc/ro/sync/ecss/extensions/api/StylesFilter.html"
          format="html" scope="external"><term>
          ro.sync.ecss.extensions.api.StylesFilter</term></xref>. </p>
      <p id="p_ojg_dgk_54b">For instance, if you want a combo box form control and the values to populate the combo are
        specified inside a file (or they come from a database). Here is how to add the form control
        from the API:</p>
      <codeblock  id="codeblock_pjg_dgk_54b">public class SDFStylesFilter implements StylesFilter {

 public Styles filter(Styles styles, AuthorNode authorNode) {
  if(authorNode.getType() == AuthorNode.NODE_TYPE_PSEUDO_ELEMENT 
      &amp;&amp; "before".equals(authorNode.getName())) {
    authorNode = authorNode.getParent();
   if ("country".equals(authorNode.getName())) {
    // This is the BEFORE pseudo element of the "country" element.
    // Read the supported countries from the configuration file.
    Map&lt;String, Object> formControlArgs = new HashMap&lt;String, Object>();
    formControlArgs.put(InplaceEditorArgumentKeys.PROPERTY_EDIT, "#text");
    formControlArgs.put(InplaceEditorArgumentKeys.PROPERTY_TYPE, 
          InplaceEditorArgumentKeys.TYPE_COMBOBOX);
    // This will be a comma separated enumeration: France, Spain, Great Britain
    String countries = readCountriesFromFile();
    formControlArgs.put(InplaceEditorArgumentKeys.PROPERTY_VALUES, countries);
    formControlArgs.put(InplaceEditorArgumentKeys.PROPERTY_EDITABLE, "false");

    // We also add a label in form of the form control.
    Map&lt;String, Object> labelProps = new HashMap&lt;String, Object>();
    labelProps.put("text", "Country: ");
    labelProps.put("styles", "* {width: 100px; color: gray;}");
    StaticContent[] mixedContent = new StaticContent[] 
           {new LabelContent(labelProps),new EditorContent(formControlArgs)};
    styles.setProperty(Styles.KEY_MIXED_CONTENT, mixedContent);
      }
    }
    
    // The added form control is the only way the element can be edited.
    if ("country".equals(authorNode.getName())) {
      styles.setProperty(Styles.KEY_VISIBITY, "-oxy-collapse-text");
    }

    return styles;
  }
}</codeblock>
      <p id="p_qjg_dgk_54b">If the execution of the
          <codeph>formControlArgs.put(InplaceEditorArgumentKeys.PROPERTY_VALUES,
          countries);</codeph> line consumes too much execution time (for example, if it connects to
        a database or if it needs to extract data from a very large file), you can choose to delay
        it until the values are actually needed by the form control. This approach is called
          <term>lazy evaluation</term> and can be implemented as
        follows:<codeblock  id="codeblock_rjg_dgk_54b">formControlArgs.put(InplaceEditorArgumentKeys.PROPERTY_VALUES, 
           new LazyValue&lt;List&lt;CIValue>>() {
  public java.util.List&lt;CIValue> get() {
    // We avoid reading the possible values until they are actually requested.
    // This will be a List with CIValues created over countries:
           France, Spain, Great Britain
    return readCountriesFromFile();
  }
});</codeblock></p>
      <p id="p_sjg_dgk_54b">The lazy evaluation approach can be used for the following form controls properties:<ul id="ul_tjg_dgk_54b">
          <li id="li_ujg_dgk_54b"
            ><uicontrol>InplaceEditorArgumentKeys.PROPERTY_VALUES</uicontrol></li>
          <li id="li_vjg_dgk_54b"
            ><uicontrol>InplaceEditorArgumentKeys.PROPERTY_LABELS</uicontrol></li>
          <li id="li_wjg_dgk_54b"
            ><uicontrol>InplaceEditorArgumentKeys.PROPERTY_TOOLTIPS</uicontrol></li>
        </ul></p>
      <p id="p_xjg_dgk_54b">The full source code for this example is available inside the <xref
          href="https://www.oxygenxml.com/oxygen_sdk.html#XML_Editor_Authoring_SDK" format="html"
          scope="external">Oxygen SDK</xref>.</p>
    </section>
  </body>
</topic>
